package net.idylls.pathos

import com.google.inject.Provides
import javax.inject.Inject
import lombok.extern.slf4j.Slf4j

import net.runelite.api.Client
import net.runelite.client.plugins.Plugin
import net.runelite.client.plugins.PluginDescriptor
import net.runelite.client.config.ConfigManager
import net.runelite.client.ui.overlay.OverlayManager

@Slf4j
@PluginDescriptor(
	name = "Pathos"
)
public class PathosPlugin : Plugin() {
	@Inject
	lateinit final var config: PathosConfig

	@Inject
	lateinit final var client: Client

	@Inject
	lateinit final var overlayManager: OverlayManager

	@Inject
	lateinit final var overlay: Overlay

	override fun startUp() {
		this.overlayManager.add(this.overlay)
	}

	override fun shutDown() {
		this.overlayManager.remove(this.overlay)
	}

	@Provides
	fun provideConfig(cm: ConfigManager): PathosConfig {
		return cm.getConfig(PathosConfig::class.java)
	}
}
